/** calc_areas.c  Calculate and print the areas of the polygons in this map. Ret # pols.
Last modified: Tue Aug 21 13:09:22 EDT 1990
	%W%	%G%	*/

#include "overlay.h"
#include <stdio.h>


int
calc_areas(v, e, ne)
    VERTEX_T v[];
    EDGE_T  e[];
    int     ne;
{
    int     hsize;		/* Use the number of edges as the hash table size
				 * since the number of polygons isn't known yet.  It
				 * should be more than adequate. */
    int     i, n, pl, pr;
    long int v1, v2;
    float   x1, y1, x2, y2, a, unscale;
    HASH_RECORD_T *table, *list;

    hsize = ne;
    unscale = rrx * rry;
    table = create_hash_table(hsize);
    for (i = 0; i < ne; i++) {
	GET_EDGE_COORDS(i);
	a = 0.5 * (x1 * y2 - x2 * y1);
	if (pl != 0)
	    find_hash_key_add_value(table, (HASH_KEY_T) pl, a);
	if (pr != 0)
	    find_hash_key_add_value(table, (HASH_KEY_T) pr, -a);
    };
    n = get_hash_n_records(table);
    list = pack_hash_table(table);
    if (debug_calc_areas) {
	printf("\n= Areas of %d polygons in this map:\n", n);
	for (i = 0; i < n; i++)
	    printf("%5d: %9.5g\n", (list + i)->k, (list + i)->v * unscale);
    }
    return (n);
}
