/** calc_edge_eqns.c   Calculate all the edge equations for this map,
and store into the edge structure.

Assumes the vertex coords were scaled so that no division is necessary

Last modified: Sun Apr  1 19:37:39 EDT 1990
	%W%	%G%	*/

#include "overlay.h"

calc_edge_eqns(mapno)
    int     mapno;
{
    int     ie;
    int     v1, v2;
    VERT_COORD_T x1, y1, x2, y2;
    EDGE_T *cur;

    for (ie = 0; ie < n_edges[mapno]; ie++) {
	cur = &edges[mapno][ie];
	v1 = cur->v1;
	v2 = cur->v2;
	x1 = vertices[mapno][v1].x;
	y1 = vertices[mapno][v1].y;
	x2 = vertices[mapno][v2].x;
	y2 = vertices[mapno][v2].y;

	cur->c = -x1 * (INTERMED_COORD_T) (cur->a = y1 - y2) -
	    y1 * (INTERMED_COORD_T) (cur->b = x2 - x1);

	if (cur->a == 0 && cur->b == 0)
	    printf("Map %d, edge %d between vertices %d %d has zero length.\n", mapno, ie, v1, v2);

	/* Normalize so points below in Y give -ve. */

	if (cur->b < 0) {
	    cur->a = -cur->a;
	    cur->b = -cur->b;
	    cur->c = -cur->c;
	}
    };
}
