/** extract_edges.c  Split the chains into edges.
Last modified: Mon Aug 13 16:48:12 EDT 1990
	%W%	%G%	*/

#include "overlay.h"
#include <stdio.h>

void
extract_edges(mapno, chain, nchain)
    CHAIN   chain[];
    int     mapno, nchain;

{
    int     ipt, npt, lpol, rpol, ichain;
    int     ne;
    int     base;		/* number of points in v before current chain */
    EDGE_T *this_edge;
    VERTEX_T *this_v1, *this_v2;

    base = ne = 0;

    for (ichain = 0; ichain < nchain; ichain++) {
	npt = chain[ichain].num_vert;
	lpol = chain[ichain].lpol;
	rpol = chain[ichain].rpol;
	check_polygon_id(&lpol);
	check_polygon_id(&rpol);

	for (ipt = 1; ipt < npt; ipt++) {
	    this_edge = &edges[mapno][ne];
	    this_edge->v1 = base + ipt - 1;
	    this_edge->v2 = base + ipt;
	    this_edge->pl = lpol;
	    this_edge->pr = rpol;

	    /* Delete this edge if it is zero length (after scaling) */

	    this_v1 = &vertices[mapno][this_edge->v1];
	    this_v2 = &vertices[mapno][this_edge->v2];
	    if (this_v1->x == this_v2->x && this_v1->y == this_v2->y) {
		printf("In map #%d, chain #%d, lpol=%d, rpol=%d, edge #%d has len=0. Deleted.\n",
		       mapno, ichain, lpol, rpol, ipt - 1);
		ne--;
	    }
	    if (ne++ >= MAX_EDGES)
		myerror("Too many edges in extract_edges.");
	};
	base += npt;
    };

    n_edges[mapno] = ne;
    calc_edge_eqns(mapno);

}

check_polygon_id(id)
    int    *id;
{
    if (*id < POLYGON_ID_MIN || *id > POLYGON_ID_MAX) {
	/**
		printf("Polygon id=%d must be between %d and %d. Changed.\n",
		       *id, POLYGON_ID_MIN, POLYGON_ID_MAX);
	*/
	/* Fix later - just a hack */
	*id = -(*id);
    }
}
