/** scale_vertices.c
Wm. Randolph Franklin
Last modified: by Wm Randolph Franklin (wrf) on mab.ecse.rpi.edu at Sun Nov 24 20:14:38 1991
	%W%	%G%	*/
/*
 * Scale the map's vertices to fall in [INTERNAL_MIN, INTERNAL_MAX].  Do this for
 * both maps after they are read in so that they are scaled together. Print average
 * edge length.
 */

#include "overlay.h"
#include <math.h>

scale_vertices(fv, v, chain, n_chains)
    FLOAT_VERTEX_T fv[];
    VERTEX_T v[];
    CHAIN   chain[];
    int     n_chains;

{
    int     i, j, k;
    float   sum = 0., avg_edge;
    int     num_edges;
    INTERMED_COORD_T dx, dy;

    i = 0;
    num_edges = 0;

    for (k = 0; k < n_chains; k++) {
	for (j = 0; j < chain[k].num_vert; j++) {
	    v[i].x = SCALEX(fv[i].x);
	    v[i].y = SCALEY(fv[i].y);
	    i++;
	}
    }

    /* Find the average edge length */

    i = 1;

    for (k = 0; k < n_chains; k++) {

	for (j = 1; j < chain[k].num_vert; j++) {

	    /* abolish sqrt for speed.  Each is 590 msec on a Sun 3/60 using cc -g. */
	    dx = v[i].x - v[i - 1].x;
	    dy = v[i].y - v[i - 1].y;
	    /* sum += sqrt((double)(dx * dx) + (double)(dy * dy)); */
#define ABS(x) ((x)>0 ? (x) : (-x))
	    sum += ABS(dx) + ABS(dy);
	    i++;
	    num_edges++;

	}			/* for j */

	i++;

    }				/* for k */



    avg_edge = sum / num_edges / INTERNAL_RANGE / 2;	/* 2 for dx and dy */
    printf("Average edge length component as fraction of map size= %f\n", avg_edge);
    printf("Scaling: intx=extx*%f+%f, inty=exty*%f+%f\n", rx, deltax, ry, deltay);

}
