/** timers.c
Wm. Randolph Franklin
Last modified: Tue Aug 21 13:49:43 EDT 1990
	%W%	%G%
*/

/*
 * Returns time in seconds since last read_delta_time.  Automatically initializes
 * itself on 1st call and returns 0.
 */

#include <sys/types.h>
#include <sys/times.h>
#include <stdio.h>

char   *malloc();

double
read_delta_time()
{
    static struct tms *time_buffer;
    static time_t old_time, new_time;	/* in 60ths of a second */
    double  delta;

    if (time_buffer == NULL) {
	time_buffer = (struct tms *) malloc((unsigned) sizeof(struct tms));
	return old_time = 0;
    }
    (void) times(time_buffer);
    new_time = time_buffer->tms_utime + time_buffer->tms_stime;
    delta = (new_time - old_time) / 60.;
    old_time = new_time;
    return delta;
}
